<template>
    <Table
        ref="orderTable"
        :tableParams="tableParams"
        :btnRole="[]"
        :right-btn="[]"
        isEmail
        @selectionChange="handleSelectionChange"
        isCurrentChange
        @currentChange="emailContent"
    >
        <template #left>
            <el-button @click="setAllRead()">全部已读</el-button>
            <el-button @click="setRead('')">设为已读</el-button>
            <el-button @click='CompletelyDel("")'>删除</el-button>
            <el-button @click='CompletelyDel("complete")'>彻底删除</el-button>
        </template>
    </Table>
</template>

<script setup lang="ts">
    import Table from '@/components/Table/index.vue'
    import { tableTypes } from '@/components/Table/types'
    import { listEmails,markStar,markAllRead,getEmails,markRead,trashEmails,completelyDelEmails} from '@/api/emails';
    import { EmailsVO, EmailsQuery } from '@/api/emails/types';
    import { Star,StarFilled } from "@element-plus/icons-vue"
    import SvgIcon from '@/components/SvgIcon/index.vue'
    const emits = defineEmits(['refresh', 'emailContent', 'delChange', 'readChange'])
    const emailContent = (val: any) => {
        if(val) {
            emits('emailContent', val)
            if(val.isRead == 0){
                setRead(val)
            }
        }
    }
    const router: any = useRouter();
    const tableParams = reactive<tableTypes<EmailsQuery, EmailsVO>>({
        tableColumn: [
            {
                show: true,
                label: '发件人',
                prop: 'fromName',
                sortable: false,
                render: ({column}: { column: EmailsVO }) => {
                    let name = []
                    let nameItem = []
                    let style = column.isRead == 1 ? '' : 'font-weight: bold;'
                    if(column.customerls && column.customerls.length != 0) {
                        column.customerls.map(item => {
                            if(item.isDelete) {
                                name.push(item.customerName + '（已删除）')
                                nameItem.push({
                                    style,
                                    class: '',
                                })
                            }else if(!item.isMyCustomer) {
                                name.push(item.customerName +
                                    `（${ item.ownerByName ? (item.ownerByName + '的客户') : (item.hasGarbageCustomer ? '无效客户' : '公海客户') }）`
                                )
                                nameItem.push({
                                    style,
                                    class: '',
                                })
                            }else{
                                name.push(item.customerName)
                                nameItem.push({
                                    style,
                                    class: 'link',
                                    onClick: async ($event) => {
                                        $event.stopPropagation()
                                        const { href } = router.resolve({
                                            path: '/customer/followPanel',
                                            query: {
                                                id: item.id,
                                                resourceType: item.customerForm
                                            }
                                        })
                                        window.open(href, '_blank')
                                    }
                                })
                            }
                        })
                    }else {
                        name.push(column.fromName || column.from)
                        nameItem.push({
                            style,
                            class: '',
                        })
                    }
                    let nameHtml = []
                    for(let i = 0;i < name.length; i++) {
                        nameHtml.push(h(
                            'span',
                            nameItem[i],
                            name[i]
                        ))
                    }
                    return [
                        h('div',{style:'display:flex;align-items: center'},[
                            h(ElIcon, [
                                h(column.isStar?StarFilled:Star,{
                                    class:'star_icon',
                                    style:column.isStar?'color:#1874ff;':'',
                                    onClick: async ($event) => {
                                        $event.stopPropagation()
                                        setStar(column)
                                    }
                                })
                            ]),
                            h('div', { class: 'email_title' }, nameHtml)
                        ])
                    ]
                }
            },
            {
                show: true,
                label: '主题',
                prop: 'subject',
                sortable: false,
                render: ({column}: { column: EmailsVO }) => {
                    let query: any = { id: column.id }
                    if(column.customerls && column.customerls.length == 1) {
                        query.customerId = column.customerls[0].id
                        query.resourceType = column.customerls[0].customerForm
                    }
                    let annex = null
                    if(column.attachmentNum) {
                        annex = h(SvgIcon, { 'iconClass': 'email-annex', style: { 'margin-right': '2px', width: '16px', height: '16px' } })
                    }
                    return [
                        h('div', { style: { display: 'flex', 'align-items': 'center' } }, [
                            annex,
                            h('div', {
                                class: 'link',
                                style:column.isRead==1?'':'font-weight: bold;color:#333',
                                onClick: async ($event) => {
                                    $event.stopPropagation()
                                    if(column.isRead == 0){
                                        setRead(column)
                                    }
                                    const { href } = router.resolve({
                                        path: '/customer/followPanel/detail',
                                        query
                                    })
                                    window.open(href, '_blank')
                                }
                            }, column.subject)
                        ])
                    ]
                }
            },
            { show: true, label: '日期', prop: 'sentDate', sortable: false },
            { show: true, label: '大小', prop: 'emailSizeName', sortable: false }
        ],
        queryParams: {
            systemMail: 1,
            blurry: ''
        },
        listFn: listEmails
    })

    const { queryParams } = toRefs(tableParams)

    const setStar = (item:any) => {
        let params = {
            isStar:item.isStar?0:1,
            emailId:item.id,
        }
        markStar(params).then(res => {
            if(res.success) {
                handleQuery()
            }
        })
    }

    const ids = ref([])
    const single:any = ref(0)
    /** 多选框选中数据 */
    const handleSelectionChange = (selection: EmailsVO[]) => {
        ids.value = selection.map(item => item.id);
        single.value = selection.length;
    }

    const setRead = (data:any) =>{
        let id = data.id
        if(single.value == 0 && data==''){
            ElMessage.error('请选择邮件')
        }else{
            let params = {
                emailIds:ids.value,
                isRead:1
            }
            if(data!=''){
                params.emailIds=id
            }
            markRead(params).then(res => {
                if(res.success) {
                    if(data!='') {
                        data.isRead = 1
                    }else{
                        handleQuery()
                    }
                    emits('readChange')
                }
            })
        }
    }

    const setAllRead = () =>{
        markAllRead().then(res => {
            if(res.success) {
                handleQuery()
                emits('readChange')
            }
        })
    }

    const CompletelyDel = (val:string) =>{
        if(single.value == 0){
            ElMessage.error('请选择需要删除的邮件')
        }else{
            let params = {
                emailIds:ids.value,
            }
            let tips = val==''?'':'彻底'
            ElMessageBox.confirm(
                '是否确认'+tips+'删除当前邮件？',
                '确认提示',
                { type: 'warning', confirmButtonText: '提交' }
            ).then(() => {
                if(val==''){
                    let params = {
                        emailIds:ids.value,
                        isTrash:1,
                    }
                    trashEmails(params).then(res => {
                        if(res.success) {
                            ElMessage.success('邮件已移至垃圾箱')
                            handleQuery()
                            emits('readChange')
                        }
                    })
                }else{
                    completelyDelEmails(ids.value).then(res => {
                        if(res.success) {
                            ElMessage.success('邮件已删除成功')
                            handleQuery()
                            emits('readChange')
                        }
                    })
                }

            }).catch(() => {})
        }
    }

    /** 搜索操作 */
    const orderTable = ref()
    const handleQuery = () => {
        orderTable.value.getData()
    }

    defineExpose({
        handleQuery,
        queryParams
    })
</script>

